
// Package: Thanks::SHA512

// File: GflSHA512.h
//		SHA512vZCu
//
//	SYN (<http://www.emit.jp/sha/sha.html>) 
//	ɂ\[XR[hgpĒĂ܂BӁI
//
// General Function Library  Copyright (C) 2000,2001 SYN All Rights Reserved.
//


//////////////////////////////////////////////////////////////////////////////
// General Function Library  Copyright (C) 2000,2001 SYN All Rights Reserved.
//////////////////////////////////////////////////////////////////////////////
#ifndef __GflSHA512_h__
#define __GflSHA512_h__

typedef unsigned __int64 QWORD;

#define SHA512_HASH   8
#define SHA512_BLOCK 16
#define SHA512_WORK  80
#define SHA512_BUFFER_SIZE (SHA512_BLOCK * 8)

class GflSHA512{
protected:
	BOOL  m_bMMX;
	QWORD m_qwH[SHA512_HASH];
	QWORD m_qwLNumBits;
	QWORD m_qwHNumBits;
	QWORD m_aBlock[SHA512_BLOCK];
	int   m_nNumChr;
protected:
	void Generate(void);
	void MMX_Generate(void);
	inline DWORD ReverseEndian(DWORD x) {return (x << 24) | ((x & 0x0000ff00) << 8) | ((x & 0x00ff0000) >> 8) | (x >> 24);}
	inline QWORD ReverseEndian(QWORD x) {return ((QWORD)ReverseEndian((DWORD)(x & 0x00000000ffffffff)) << 32) | ReverseEndian((DWORD)(x >> 32));}
	inline QWORD Rotate(QWORD x, DWORD n) {return (x >> n) | (x << (64 - n));}
	inline QWORD Ch(QWORD x, QWORD y, QWORD z) {return (x & (y ^ z)) ^ z;}
	inline QWORD Maj(QWORD x, QWORD y, QWORD z) {return (x & (y | z)) | (y & z);}
	inline QWORD S0(QWORD x) {return Rotate(x, 28) ^ Rotate(x, 34) ^ Rotate(x, 39);}
	inline QWORD S1(QWORD x) {return Rotate(x, 14) ^ Rotate(x, 18) ^ Rotate(x, 41);}
	inline QWORD s0(QWORD x) {return Rotate(x,  1) ^ Rotate(x,  8) ^ (x >> 7);}
	inline QWORD s1(QWORD x) {return Rotate(x, 19) ^ Rotate(x, 61) ^ (x >> 6);}
public:
	GflSHA512(void);
	virtual ~GflSHA512(void);
public:
	virtual void Init(void);
	virtual void Load(BYTE *pBuffer, DWORD dwSize);
	virtual void Final(void);
	virtual string GetDigest(void);
};


// added by k.inaba
template<typename T>
inline string calc_sha512( const vector<T>& buf )
{
	GflSHA512 sha;
	sha.Init();
	sha.Load( const_cast<BYTE*>( (const BYTE*)&buf[0] ), DWORD(buf.size()*sizeof(T)) );
	sha.Final();
	return sha.GetDigest();
}


#endif  __GflSHA512_h__
