#pragma once

//=========================================================================
// Package: klx::opfun
//		Zq֐IuWFNg
//
//	WCu std::less Ȃǂ́Aless<int>() Ƃ悤ɁA
//	Kp^𖾎w肵Ȃ΂ȂȂ̂ʓ|łB
//
//	: sort( v.begin(), v.end(), klx::op_less() );
//
//	ĂȊɁA^𖾎w肵ȂĂ̂܂B
//	̑ std::not2 ȂǂɓnȂȂƂ_B
//	klx::not2 ȂǂΉ̂ŁAKvɂȂ܂B
//=========================================================================

#include "metaprog.hpp"
namespace klx {



#define KLX_DEFINE_RELFUN_1( NAME, OP ) \
	struct KLX_PP_CAT(op_,NAME)         \
	{                                   \
	  typedef bool result_type;         \
	  template<typename A>              \
	  bool operator()(const A& a) const \
	  {                                 \
	    return OP a;                    \
	  }                                 \
	};

#define KLX_DEFINE_RELFUN_2( NAME, OP )             \
	struct KLX_PP_CAT(op_,NAME)                     \
	{                                               \
	  typedef bool result_type;                     \
	  template<typename A, typename B>              \
	  bool operator()(const A& a, const B& b) const \
	  {                                             \
	    return a OP b;                              \
	  }                                             \
	};

#define KLX_DEFINE_ARITHFUN_1( NAME, OP ) \
	struct KLX_PP_CAT(op_,NAME)           \
	{                                     \
	  template<typename A>                \
	  A operator()(const A& a) const      \
	  {                                   \
	    return OP a1;                     \
	  }                                   \
	};

#define KLX_DEFINE_ARITHFUN_2( NAME, OP )        \
	struct KLX_PP_CAT(op_,NAME)                  \
	{                                            \
	  template<typename A, typename B>           \
	  A operator()(const A& a, const B& b) const \
	  {                                          \
	    return a OP b;                           \
	  }                                          \
	  template<typename A, typename B>           \
	  A& operator()(A& a, const B& b) const      \
	  {                                          \
	    return a OP b;                           \
	  }                                          \
	};

// Struct: op_equal_to
//    fun(x,y){ return (x == y); }
KLX_DEFINE_RELFUN_2( equal_to, == );

// Struct: op_not_equal_to
//    fun(x,y){ return (x != y); }
KLX_DEFINE_RELFUN_2( not_equal_to, != );

// Struct: op_less
//    fun(x,y){ return (x < y); }
KLX_DEFINE_RELFUN_2( less, <  );

// Struct: op_less_equal
//    fun(x,y){ return (x <= y); }
KLX_DEFINE_RELFUN_2( less_equal, <= );

// Struct: op_greater
//    fun(x,y){ return (x > y); }
KLX_DEFINE_RELFUN_2( greater, > );

// Struct: op_greate_equal
//    fun(x,y){ return (x >= y); }
KLX_DEFINE_RELFUN_2( greater_equal, >= );

// Struct: op_logical_and
//    fun(x,y){ return (x && y); }
KLX_DEFINE_RELFUN_2( logical_and, && );

// Struct: op_logical_or
//    fun(x,y){ return (x || y); }
KLX_DEFINE_RELFUN_2( logical_or, || );

// Struct: op_logical_not
//    fun(x){ return (!x); }
KLX_DEFINE_RELFUN_1( logical_not, ! );

// Struct: op_plus
//    fun(x,y){ return (x + y); }
KLX_DEFINE_ARITHFUN_2( plus, + );

// Struct: op_minus
//    fun(x,y){ return (x - y); }
KLX_DEFINE_ARITHFUN_2( minus, - );

// Struct: op_multiplies
//    fun(x,y){ return (x * y); }
KLX_DEFINE_ARITHFUN_2( multiplies, * );

// Struct: op_devides
//    fun(x,y){ return (x / y); }
KLX_DEFINE_ARITHFUN_2( devides, / );

// Struct: op_modulus
//    fun(x,y){ return (x % y); }
KLX_DEFINE_ARITHFUN_2( modulus, % );

// Struct: op_negate
//    fun(x,y){ return (-x); }
KLX_DEFINE_ARITHFUN_1( negate, - );

// Struct: op_bit_and
//    fun(x,y){ return (x & y); }
KLX_DEFINE_ARITHFUN_2( bit_and, & );

// Struct: op_bit_or
//    fun(x,y){ return (x | y); }
KLX_DEFINE_ARITHFUN_2( bit_or, | );

// Struct: op_bit_xor
//    fun(x,y){ return (x ^ y); }
KLX_DEFINE_ARITHFUN_2( bit_xor, ^ );

// Struct: op_bit_invert
//    fun(x,y){ return (~x); }
KLX_DEFINE_ARITHFUN_1( op_bit_invert, ~ );

// Struct: op_lshift
//    fun(x,y){ return (x << y); }
KLX_DEFINE_ARITHFUN_2( lshift, << );

// Struct: op_rshift
//    fun(x,y){ return (x >> y); }
KLX_DEFINE_ARITHFUN_2( rshift, >> );

// Struct: op_delete
//		fun(x) { delete x; }
struct op_delete
{
	typedef void result_type;
	template<typename T>
	void operator()( T* p ) const
	{
		delete p;
	}
};

// Struct: op_delete_array
//		fun(x) { delete[] x; }
struct op_delete_array
{
	typedef void result_type;
	template<typename T>
	void operator()( T* p ) const
	{
		delete[] p;
	}
};

// Struct: op_nothing
//		fun(...) {}
struct op_nothing
{
	typedef void result_type;
		void operator()() const {}
	template<typename T1>
		void operator()( const T1& ) const {}
	template<typename T1, typename T2>
		void operator()( const T1&, const T2& ) const {}
	template<typename T1, typename T2, typename T3>
		void operator()( const T1&, const T2&, const T3& ) const {}
	template<typename T1, typename T2, typename T3, typename T4>
		void operator()( const T1&, const T2&, const T3&, const T4& ) const {}
};

#undef KLX_DEFINE_RELFUN_1
#undef KLX_DEFINE_RELFUN_2
#undef KLX_DEFINE_ARITHFUN_1
#undef KLX_DEFINE_ARITHFUN_2



//=========================================================================
} // namespace end
