#pragma once

//============================================================================
// Package: klx::scopeguard
//		XR[vK[h
//
//>	void f()
//>	{
//>		FILE* fp = fopen( "some.dat", "r" );
//>		scope_guard grd = make_guard( &fclose, fp );
//>		...Ȃ񂩏...
//>	}
//
//	ƏĂƂŁAuȂ񂩏v̕ŗO悤
//	ɏI낤AƂɂ̊֐𔲂Ƃ fclose(fp) 
//	Ăяo悤ɂȂ@\Ă܂B
//	CUJ̋L<http://www.cuj.com/experts/1812/alexandr.htm?topic=experts>
//	ĎĂ݂K݂Ȃ̂łBƎ̊gƂāAON_EXCEPTION
//	ǉĂ܂BON_EXCEPTIONAO߂͏
//	s邽߁AfXgN^Ăяo\̂֐ŎgƁA
//	҂Ȃ\܂BӁB
//
//	[֐]
//
//>	make_guard :
//>	  function -> [parameters] -> scope_guard
//>		֐|C^/֐IuWFNgƈ󂯎āA
//>		XR[vK[hԂ܂B
//>		EQƓnɂꍇ́Aboost::ref ȂǂgƁB
//>		Evc, gcc ł́Ão֐łꍇɌA
//>		  make_obj_guard Ɠ̓s܂B܂Aʏ
//>		  _obj t̊֐/}N͏L̂QRpCł͎gKv͂܂B
//>
//>	make_obj_guard :
//>	  object& -> mem_function -> [parameters]* -> scope_guard
//>		IuWFNgƂ̃o֐ƈ󂯎āAXR[vK[hԂ܂B
//>
//>	make_undo_guard :
//>	  function -> [parameters] -> scope_guard
//>		make_guard ƓłA͗O߂̎ɂs܂B
//>		܂AɍŌɍsł͂ȂAOSۂ߂
//>		undôƂɗpoK[h쐬܂B
//>
//>	make_obj_undo_guard :
//>	  object& -> mem_function -> [parameters]* -> scope_guard
//>		make_obj_guard  undo ŁB
//
// [}N]
//
//	ON_BLOCK_END,  ON_BLOCK_END_OBJ,  ON_EXCEPTION,  ON_EXCEPTION_OBJ 
//	S̃}N`Ă܂BꂼÃK[hIuWFNg
//	 make_guard, make_obj_guard, make_undo_guard, make_obj_undo_guard
//	ō쐬}NɂȂĂ܂B
//
//>	void Class::f()
//>	{
//>		FILE* fp = fopen( "some.dat", "r" );
//>		ON_BLOCK_EXIT( &fclose, fp );
//>			// ֐𔲂Ƃɂ͕Kt@C
//>		m_vector.push_back( fgetc(fp) );
//>		ON_EXCEPTION_OBJ( m_vector, &vector<char>::pop_back );
//>			// Oɂpush_back
//>		... Ȃ񂩏 ...
//>	}
//
//============================================================================

#include <exception>
#include "metaprog.hpp"
namespace klx {



namespace detail
{
	//
	// NXBq悤 const & ŕϐ𔛂邱Ƃ
	// Ԃ邽߁A{Ȃ virtual ͈ؕKvȂB
	// ABccɑ΂Ă̂workaroundƂvirtualKvB
	//

	class scope_guard_base
	{
	public:
		void dismiss() const { dismissed = true; }
	protected:
		bool should_invoke_guard() const { return !dismissed; }
	protected:
		scope_guard_base() : dismissed(false) {}
		scope_guard_base(const scope_guard_base& rhs)
		  : dismissed(rhs.dismissed) { rhs.dismiss(); }
	  #if KLX_COMPILER_IS_NOT_BCC
		~scope_guard_base() {}
	  #else
		public: virtual ~scope_guard_base() {}
	  #endif
	private:
		mutable bool dismissed;
	private:
		void operator=(const scope_guard_base&); //forbidden
	};

	//
	// OȊOGuardNȂꍇ̊NX
	// should_invoke_guard ̔ɁAstd::uncaught_exception() ǉ܂B
	//
	class scope_guard_base_ex
		: public scope_guard_base
	{
	protected:
		bool should_invoke_guard() const {
			return scope_guard_base::should_invoke_guard()
			    && std::uncaught_exception();
		}
	};

	//
	// ڍחp̃}NBK[ht֐N
	//
	#define KLX_SG_DO( s ) if( should_invoke_guard() ) try { s; } catch(...) {}

	//
	// t[֐Np̃K[hNXBT܂
	//
	template<class P,class Fn> struct sg0 : P {
		sg0(const Fn& fn) : fn(fn) {}
		~sg0() { KLX_SG_DO( fn() ) }
		private: Fn fn;
	};
	template<class P,class Fn,class A> struct sg1 : P {
		sg1(const Fn& fn, const A& a) : fn(fn), a(a) {}
		~sg1() { KLX_SG_DO( fn(a) ) }
		private: Fn fn; A a;
	};
	template<class P,class Fn,class A,class B> struct sg2 : P {
		sg2(const Fn& fn, const A& a, const B& b) : fn(fn), a(a), b(b) {}
		~sg2() { KLX_SG_DO( fn(a,b) ) }
		private: Fn fn; A a; B b;
	};
	template<class P,class Fn,class A,class B,class C> struct sg3 : P {
		sg3(const Fn& fn, const A& a, const B& b,
		    const C& c) : fn(fn), a(a), b(b), c(c) {}
		~sg3() { KLX_SG_DO( fn(a,b,c) ) }
		private: Fn fn; A a; B b; C c;
	};
	template<class P,class Fn,class A,class B,class C,class D> struct sg4 : P {
		sg4(const Fn& fn, const A& a, const B& b,
		    const C& c, const D& d) : fn(fn), a(a), b(b), c(c), d(d) {}
		~sg4() { KLX_SG_DO( fn(a,b,c,d) ) }
		private: Fn fn; A a; B b; C c; D d;
	};
	template<class P,class Fn,class A,class B,class C,class D,class E>
		struct sg5 : P {
		sg5(const Fn& fn, const A& a, const B& b, const C& c,
		    const D& d, const E& e) : fn(fn), a(a), b(b), c(c), d(d), e(e) {}
		~sg5() { KLX_SG_DO( fn(a,b,c,d,e) ) }
		private: Fn fn; A a; B b; C c; D d; E e;
	};

	//
	// o֐p̃K[hNXBT܂
	//
	template<class P,class Ob,class Fn> struct sgm0 : P {
		sgm0(Ob& ob, const Fn& fn) : ob(ob), fn(fn) {}
		~sgm0() { KLX_SG_DO( (ob.*fn)() ) }
		private: Ob& ob; Fn fn;
	};
	template<class P,class Ob,class Fn,class A> struct sgm1 : P {
		sgm1(Ob& ob,const Fn& fn, const A& a) : ob(ob), fn(fn), a(a) {}
		~sgm1() { KLX_SG_DO( (ob.*fn)(a) ) }
		private: Ob& ob; Fn fn; A a;
	};
	template<class P,class Ob,class Fn,class A,class B> struct sgm2 : P {
		sgm2(Ob& ob,const Fn& fn, const A& a, const B& b) : ob(ob), fn(fn), a(a), b(b) {}
		~sgm2() { KLX_SG_DO( (ob.*fn)(a,b) ) }
		private: Ob& ob; Fn fn; A a; B b;
	};
	template<class P,class Ob,class Fn,class A,class B,class C> struct sgm3 : P {
		sgm3(Ob& ob,const Fn& fn, const A& a, const B& b, const C& c)
		  : ob(ob), fn(fn), a(a), b(b), c(c) {}
		~sgm3() { KLX_SG_DO( (ob.*fn)(a,b,c) ) }
		private: Ob& ob; Fn fn; A a; B b; C c;
	};
	template<class P,class Ob,class Fn,class A,class B,class C,class D>
		struct sgm4 : P {
		sgm4(Ob& ob,const Fn& fn, const A& a, const B& b, const C& c,
		    const D& d) : ob(ob), fn(fn), a(a), b(b), c(c), d(d) {}
		~sgm4() { KLX_SG_DO( (ob.*fn)(a,b,c,d) ) }
		private: Ob& ob; Fn fn; A a; B b; C c; D d;
	};
	template<class P,class Ob,class Fn,class A,class B,class C,class D,class E>
		struct sgm5 : P {
		sgm5(Ob& ob,const Fn& fn, const A& a, const B& b, const C& c,
		    const D& d, const E& e) : ob(ob), fn(fn), a(a), b(b), c(c), d(d), e(e) {}
		~sgm5() { KLX_SG_DO( (ob.*fn)(a,b,c,d,e) ) }
		private: Ob& ob; Fn fn; A a; B b; C c; D d; E e;
	};

	#undef KLX_SG_DO
}

//
// K[hN|V[
//
typedef detail::scope_guard_base    sgAnyCase;
typedef detail::scope_guard_base_ex sgExceptionCase;

//-------------------------------------------------------------------------
// Function: make_guard(...)
//		ubNIɏɎsw肵܂B
//-------------------------------------------------------------------------

template<class F>
detail::sg0<sgAnyCase,F> make_guard( const F& f ) { return detail::sg0<sgAnyCase,F>(f); }
template<class F,class A>
detail::sg1<sgAnyCase,F,A> make_guard( const F& f, const A& a ) { return detail::sg1<sgAnyCase,F,A>(f,a); }
template<class F,class A,class B>
detail::sg2<sgAnyCase,F,A,B> make_guard( const F& f, const A& a, const B& b ) { return detail::sg2<sgAnyCase,F,A,B>(f,a,b); }
template<class F,class A,class B,class C>
detail::sg3<sgAnyCase,F,A,B,C> make_guard( const F& f, const A& a, const B& b, const C& c ) { return detail::sg3<sgAnyCase,F,A,B,C>(f,a,b,c); }
template<class F,class A,class B,class C,class D>
detail::sg4<sgAnyCase,F,A,B,C,D> make_guard( const F& f, const A& a, const B& b, const C& c, const D& d ) { return detail::sg4<sgAnyCase,F,A,B,C,D>(f,a,b,c,d); }
template<class F,class A,class B,class C,class D,class E>
detail::sg5<sgAnyCase,F,A,B,C,D,E> make_guard( const F& f, const A& a, const B& b, const C& c, const D& d, const E& e ) { return detail::sg5<sgAnyCase,F,A,B,C,D,E>(f,a,b,c,d,e); }

template<class O,class F>
detail::sgm0<sgAnyCase,O,F> make_obj_guard( O& o, const F& f ) { return detail::sgm0<sgAnyCase,O,F>(o,f); }
template<class O,class F,class A>
detail::sgm1<sgAnyCase,O,F,A> make_obj_guard( O& o, const F& f, const A& a ) { return detail::sgm1<sgAnyCase,O,F,A>(o,f,a); }
template<class O,class F,class A,class B>
detail::sgm2<sgAnyCase,O,F,A,B> make_obj_guard( O& o, const F& f, const A& a, const B& b ) { return detail::sgm2<sgAnyCase,O,F,A,B>(o,f,a,b); }
template<class O,class F,class A,class B,class C>
detail::sgm3<sgAnyCase,O,F,A,B,C> make_obj_guard( O& o, const F& f, const A& a, const B& b, const C& c ) { return detail::sgm3<sgAnyCase,O,F,A,B,C>(o,f,a,b,c); }
template<class O,class F,class A,class B,class C,class D>
detail::sgm4<sgAnyCase,O,F,A,B,C,D> make_obj_guard( O& o, const F& f, const A& a, const B& b, const C& c, const D& d ) { return detail::sgm4<sgAnyCase,O,F,A,B,C,D>(o,f,a,b,c,d); }
template<class O,class F,class A,class B,class C,class D,class E>
detail::sgm5<sgAnyCase,O,F,A,B,C,D,E> make_obj_guard( O& o, const F& f, const A& a, const B& b, const C& c, const D& d, const E& e ) { return detail::sgm5<sgAnyCase,O,F,A,B,C,D,E>(o,f,a,b,c,d,e); }

#if KLX_COMPILER_IS_VC || KLX_COMPILER_IS_GCC
template<class O,class R>
detail::sgm0<sgAnyCase,O,R(O::*)()> make_guard( O& o, R (O::*f)() ) { return detail::sgm0<sgAnyCase,O,R(O::*)()>(o,f); }
template<class O,class R,class RA,class A>
detail::sgm1<sgAnyCase,O,R(O::*)(RA),A> make_guard( O& o, R(O::*f)(RA), const A& a ) { return detail::sgm1<sgAnyCase,O,R(O::*)(RA),A>(o,f,a); }
template<class O,class R,class RA,class RB,class A,class B>
detail::sgm2<sgAnyCase,O,R(O::*)(RA,RB),A,B> make_guard( O& o, R(O::*)(RA,RB), const A& a, const B& b ) { return detail::sgm2<sgAnyCase,O,R(O::*)(RA,RB),A,B>(o,f,a,b); }
template<class O,class R,class RA,class RB,class RC,class A,class B,class C>
detail::sgm3<sgAnyCase,O,R(O::*)(RA,RB,RC),A,B,C> make_guard( O& o, R(O::*)(RA,RB,RC), const A& a, const B& b, const C& c ) { return detail::sgm3<sgAnyCase,O,R(O::*)(RA,RB,RC),A,B,C>(o,f,a,b,c); }
template<class O,class R,class RA,class RB,class RC,class RD,class A,class B,class C,class D>
detail::sgm4<sgAnyCase,O,R(O::*)(RA,RB,RC,RD),A,B,C,D> make_guard( O& o, R(O::*)(RA,RB,RC,RD), const A& a, const B& b, const C& c, const D& d ) { return detail::sgm4<sgAnyCase,O,R(O::*)(RA,RB,RC,RD),A,B,C,D>(o,f,a,b,c,d); }
template<class O,class R,class RA,class RB,class RC,class RD,class RE,class A,class B,class C,class D,class E>
detail::sgm5<sgAnyCase,O,R(O::*)(RA,RB,RC,RD,RE),A,B,C,D,E> make_guard( O& o, R(O::*)(RA,RB,RC,RD,RE), const A& a, const B& b, const C& c, const D& d, const E& e ) { return detail::sgm5<sgAnyCase,O,R(O::*)(RA,RB,RC,RD,RE),A,B,C,D,E>(o,f,a,b,c,d,e); }
#endif

//-------------------------------------------------------------------------
// Function: make_undo_guard(...)
//		OɏɎsw肵܂B
//-------------------------------------------------------------------------

template<class F>
detail::sg0<sgExceptionCase,F> make_undo_guard( const F& f ) { return detail::sg0<sgExceptionCase,F>(f); }
template<class F,class A>
detail::sg1<sgExceptionCase,F,A> make_undo_guard( const F& f, const A& a ) { return detail::sg1<sgExceptionCase,F,A>(f,a); }
template<class F,class A,class B>
detail::sg2<sgExceptionCase,F,A,B> make_undo_guard( const F& f, const A& a, const B& b ) { return detail::sg2<sgExceptionCase,F,A,B>(f,a,b); }
template<class F,class A,class B,class C>
detail::sg3<sgExceptionCase,F,A,B,C> make_undo_guard( const F& f, const A& a, const B& b, const C& c ) { return detail::sg3<sgExceptionCase,F,A,B,C>(f,a,b,c); }
template<class F,class A,class B,class C,class D>
detail::sg4<sgExceptionCase,F,A,B,C,D> make_undo_guard( const F& f, const A& a, const B& b, const C& c, const D& d ) { return detail::sg4<sgExceptionCase,F,A,B,C,D>(f,a,b,c,d); }
template<class F,class A,class B,class C,class D,class E>
detail::sg5<sgExceptionCase,F,A,B,C,D,E> make_undo_guard( const F& f, const A& a, const B& b, const C& c, const D& d, const E& e ) { return detail::sg5<sgExceptionCase,F,A,B,C,D,E>(f,a,b,c,d,e); }

template<class O,class F>
detail::sgm0<sgExceptionCase,O,F> make_obj_undo_guard( O& o, const F& f ) { return detail::sgm0<sgExceptionCase,O,F>(o,f); }
template<class O,class F,class A>
detail::sgm1<sgExceptionCase,O,F,A> make_obj_undo_guard( O& o, const F& f, const A& a ) { return detail::sgm1<sgExceptionCase,O,F,A>(o,f,a); }
template<class O,class F,class A,class B>
detail::sgm2<sgExceptionCase,O,F,A,B> make_obj_undo_guard( O& o, const F& f, const A& a, const B& b ) { return detail::sgm2<sgExceptionCase,O,F,A,B>(o,f,a,b); }
template<class O,class F,class A,class B,class C>
detail::sgm3<sgExceptionCase,O,F,A,B,C> make_obj_undo_guard( O& o, const F& f, const A& a, const B& b, const C& c ) { return detail::sgm3<sgExceptionCase,O,F,A,B,C>(o,f,a,b,c); }
template<class O,class F,class A,class B,class C,class D>
detail::sgm4<sgExceptionCase,O,F,A,B,C,D> make_obj_undo_guard( O& o, const F& f, const A& a, const B& b, const C& c, const D& d ) { return detail::sgm4<sgExceptionCase,O,F,A,B,C,D>(o,f,a,b,c,d); }
template<class O,class F,class A,class B,class C,class D,class E>
detail::sgm5<sgExceptionCase,O,F,A,B,C,D,E> make_obj_undo_guard( O& o, const F& f, const A& a, const B& b, const C& c, const D& d, const E& e ) { return detail::sgm5<sgExceptionCase,O,F,A,B,C,D,E>(o,f,a,b,c,d,e); }

#if KLX_COMPILER_IS_VC || KLX_COMPILER_IS_GCC
template<class O,class R>
detail::sgm0<sgExceptionCase,O,R(O::*)()> make_undo_guard( O& o, R (O::*f)() ) { return detail::sgm0<sgExceptionCase,O,R(O::*)()>(o,f); }
template<class O,class R,class RA,class A>
detail::sgm1<sgExceptionCase,O,R(O::*)(RA),A> make_undo_guard( O& o, R(O::*f)(RA), const A& a ) { return detail::sgm1<sgExceptionCase,O,R(O::*)(RA),A>(o,f,a); }
template<class O,class R,class RA,class RB,class A,class B>
detail::sgm2<sgExceptionCase,O,R(O::*)(RA,RB),A,B> make_undo_guard( O& o, R(O::*)(RA,RB), const A& a, const B& b ) { return detail::sgm2<sgExceptionCase,O,R(O::*)(RA,RB),A,B>(o,f,a,b); }
template<class O,class R,class RA,class RB,class RC,class A,class B,class C>
detail::sgm3<sgExceptionCase,O,R(O::*)(RA,RB,RC),A,B,C> make_undo_guard( O& o, R(O::*)(RA,RB,RC), const A& a, const B& b, const C& c ) { return detail::sgm3<sgExceptionCase,O,R(O::*)(RA,RB,RC),A,B,C>(o,f,a,b,c); }
template<class O,class R,class RA,class RB,class RC,class RD,class A,class B,class C,class D>
detail::sgm4<sgExceptionCase,O,R(O::*)(RA,RB,RC,RD),A,B,C,D> make_undo_guard( O& o, R(O::*)(RA,RB,RC,RD), const A& a, const B& b, const C& c, const D& d ) { return detail::sgm4<sgExceptionCase,O,R(O::*)(RA,RB,RC,RD),A,B,C,D>(o,f,a,b,c,d); }
template<class O,class R,class RA,class RB,class RC,class RD,class RE,class A,class B,class C,class D,class E>
detail::sgm5<sgExceptionCase,O,R(O::*)(RA,RB,RC,RD,RE),A,B,C,D,E> make_undo_guard( O& o, R(O::*)(RA,RB,RC,RD,RE), const A& a, const B& b, const C& c, const D& d, const E& e ) { return detail::sgm5<sgExceptionCase,O,R(O::*)(RA,RB,RC,RD,RE),A,B,C,D,E>(o,f,a,b,c,d,e); }
#endif

//-------------------------------------------------------------------------
// Macro: ON_BLOCK_END(...)
//		ubNIɎswł܂B
//
//	VC++̃oOŁA/ZI (GfBbgReBj[) IvV
//	w肳ĂƂ̃}N͎g܂B
//-------------------------------------------------------------------------

#define ON_BLOCK_END     klx::scope_guard KLX_ANON_ID(scopeGuard) = klx::make_guard
#define ON_BLOCK_END_OBJ klx::scope_guard KLX_ANON_ID(scopeGuard) = klx::make_obj_guard

//-------------------------------------------------------------------------
// Macro: ON_EXCEPTION(...)
//		OɎswł܂B
//
//	VC++̃oOŁA/ZI (GfBbgReBj[) IvV
//	w肳ĂƂ̃}N͎g܂B
//-------------------------------------------------------------------------

#define ON_EXCEPTION     klx::scope_guard KLX_ANON_ID(scopeGuard) = klx::make_undo_guard
#define ON_EXCEPTION_OBJ klx::scope_guard KLX_ANON_ID(scopeGuard) = klx::make_obj_undo_guard

//-------------------------------------------------------------------------
// Class: scope_guard
//		K[hIuWFNg
//
//	make_guard / make_undo_guard ̖߂l󂯎܂B
//-------------------------------------------------------------------------

#if KLX_COMPILER_IS_NOT_BCC
	typedef const detail::scope_guard_base& scope_guard;
#else
	struct scope_guard
	{
		template<typename SG> scope_guard( const SG& sg ) : sg( new SG(sg) ) {}
		scope_guard(const scope_guard& rhs) : sg(rhs.sg) { rhs.sg = 0; }
		~scope_guard() { delete sg; }
		// Function: dismiss
		//		K[hĎsȂ悤ɐݒ肵܂
		void dismiss() const { sg->dismiss(); }
	private:
		void operator=(const scope_guard&);
		mutable detail::scope_guard_base* sg;
	};
#endif



//============================================================================
} // end namespace
